<?php

// Precondition: $body is already sanitised
function article_add($topic, $body)
{
  $query = sprintf("INSERT INTO article (topic,uid,status,body,created,remote_addr) ".
		   "VALUES (%d,%d,%d,'%s',now(),'%s')",
		   $topic,  $_SESSION['uid'], 1, pg_escape_string($body),
		   $_SERVER['REMOTE_ADDR']);

  $sth = db_query($query);
  if ($sth === false)
    return false;

  return true;
}

function topic_add($zid, $topic, $body)
{
  db_query('BEGIN TRANSACTION');

  $query = sprintf("INSERT INTO topics (zeitung,topic,created,modified) ".
		   "VALUES (%d,'%s',now(),now())",
		   $zid, $topic);

  $sth = db_query($query);
  if ($sth === false) {
    db_query('ROLLBACK');
    return false;
  }

  $id = db_last_id('topics', 'id');
  if ($id === false) {
    db_query('ROLLBACK');
    return false;
  }

  if (article_add($id, $body) === false) {
    db_query('ROLLBACK');
    return false;
  }

  db_query('COMMIT');

  return $id;
}

function process_topic()
{
  global $cfg;
  global $zlist;

  if (isset($_GET['zeitung']) && is_numeric($_GET['zeitung']))
    $zid = $_GET['zeitung'];
  elseif (isset($_POST['zeitung']) && is_numeric($_POST['zeitung']))
    $zid = $_POST['zeitung'];
  else
    $ret = warning('Keine Zeitung oder Magazin gefunden!');

  if (isset($zid)) {
    $try = format_newspaper($zid, true);
    if ($try === false) {
      $ret .= warning('Keine Zeitung oder Magazin gefunden!');
      unset($zid);
    } else
      $ret .= $try;
  }

  if (isset($zid)) {
    if (!isset($_SESSION['uid']))
      $ret .= warning('Um eine neue Diskussion zu beginnen, mssen Sie angemeldet sein.');
    else {
      $replace = array('zeitung' => $zid);
      if (!isset($_POST['zeitung'])) {
	$ret .= information('Sie beginnen eine neue Diskussion im Forum.');
      } else {
	$replace['topic'] = htmlspecialchars($_POST['topic']);
	$replace['body'] = string_sanitise($_POST['body']);

	if (strlen($_POST['topic'])) {
	  if (strlen($_POST['body'])) {
	    if (($tid = topic_add($zid, $replace['topic'], $replace['body'])) !== false) {
	      header(sprintf('Location: %stopic/%d.html', $cfg['home'], $tid));
	    } else
	      $ret .= warning('Es ist ein Datenbankfehler aufgetreten.');
	  } else
	    $ret .= warning('Sie haben keinen Text fr die Diskussion angegeben!');
	} else
	  $ret .= warning('Sie haben keinen Titel fr die Diskussion angegeben!');
      }

      $ret .= load_javascript('topic.js') . load_template('topic.html', $replace);
    }
  }

  return $ret;
}

// Sideeffect: May set $zlist['redirect']
function process_reply()
{
  global $cfg;
  global $zlist;

  if (isset($_GET['topic']) && is_numeric($_GET['topic']))
    $topic = $_GET['topic'];
  elseif (isset($_POST['topic']) && is_numeric($_POST['topic']))
    $topic = $_POST['topic'];
  else
    $ret = warning('Keine passende Diskussion gefunden!');

  if (isset($topic)) {
    $discussion = format_topic($topic);
    if (isset($zlist['zid'])) {
      $ret .= format_newspaper($zlist['zid'], true);

      if (isset($_POST['body'])) {
	if (article_add($topic, string_sanitise($_POST['body'])) === true) {
	  $ret .= information('Danke fr Ihren Beitrag.  Sie werden automatisch zur Diskussion weitergeleitet.');
	  header(sprintf('Location: %stopic/%d.html', $cfg['home'], $topic));
	} else {
	  $ret .= warning('Ihr Beitrag konnte nicht aufgenommen werden.');
	  $ret .= $discussion;
	  $replace = array('topic' => $topic,
			   'title' => $zlist['topic'],
			   'body' => htmlspecialchars($_POST['body']));
	  $ret .= load_javascript('reply.js') . load_template('reply.html', $replace);
	}
      } else {
	$ret .= $discussion;
	$replace = array('topic' => $topic,
			 'title' => $zlist['topic']);
	$ret .= load_javascript('reply.js') . load_template('reply.html', $replace);
      }
    } else
      $ret .= $discussion;
  }

  return $ret;
}
